/[gentoo-x86]/eclass/gnome2.eclass
Gentoo

Diff of /eclass/gnome2.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.77 Revision 1.97
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/gnome2.eclass,v 1.77 2006/12/12 02:58:22 leonardop Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/gnome2.eclass,v 1.97 2011/07/08 11:35:01 ssuominen Exp $
4 4
5#
6# gnome2.eclass 5# @ECLASS: gnome2.eclass
7# 6# @MAINTAINER:
7# gnome@gentoo.org
8# @BLURB:
9# @DESCRIPTION:
8# Exports portage base functions used by ebuilds written for packages using the 10# Exports portage base functions used by ebuilds written for packages using the
9# GNOME framework. 11# GNOME framework. For additional functions, see gnome2-utils.eclass.
10#
11# Maintained by Gentoo's GNOME herd <gnome@gentoo.org>
12#
13 12
13inherit fdo-mime libtool gnome.org gnome2-utils
14 14
15inherit libtool gnome.org debug fdo-mime eutils 15case "${EAPI:-0}" in
16 0|1)
17 EXPORT_FUNCTIONS src_unpack src_compile src_install pkg_preinst pkg_postinst pkg_postrm
18 ;;
19 2|3|4)
20 EXPORT_FUNCTIONS src_unpack src_prepare src_configure src_compile src_install pkg_preinst pkg_postinst pkg_postrm
21 ;;
22 *) die "EAPI=${EAPI} is not supported" ;;
23esac
16 24
17 25# @ECLASS-VARIABLE: G2CONF
26# @DEFAULT-UNSET
27# @DESCRIPTION:
18# Extra configure opts passed to econf 28# Extra configure opts passed to econf
19G2CONF=${G2CONF:=""} 29G2CONF=${G2CONF:-""}
20 30
31# @ECLASS-VARIABLE: GNOME2_LA_PUNT
32# @DESCRIPTION:
33# Should we delete all the .la files?
34# NOT to be used without due consideration.
35GNOME2_LA_PUNT=${GNOME2_LA_PUNT:-"no"}
36
37# @ECLASS-VARIABLE: ELTCONF
38# @DEFAULT-UNSET
39# @DESCRIPTION:
21# Extra options passed to elibtoolize 40# Extra options passed to elibtoolize
22ELTCONF=${ELTCONF:=""} 41ELTCONF=${ELTCONF:-""}
23 42
43# @ECLASS-VARIABLE: USE_EINSTALL
44# @DEFAULT-UNSET
45# @DEPRECATED
46# @DESCRIPTION:
24# Should we use EINSTALL instead of DESTDIR 47# Should we use EINSTALL instead of DESTDIR
25USE_EINSTALL=${USE_EINSTALL:=""} 48USE_EINSTALL=${USE_EINSTALL:-""}
26 49
50# @ECLASS-VARIABLE: SCROLLKEEPER_UPDATE
51# @DEPRECATED
52# @DESCRIPTION:
27# Run scrollkeeper for this package? 53# Whether to run scrollkeeper for this package or not.
28SCROLLKEEPER_UPDATE=${SCROLLKEEPER_UPDATE:="1"} 54SCROLLKEEPER_UPDATE=${SCROLLKEEPER_UPDATE:-"1"}
29 55
30# Directory where scrollkeeper-update should do its work 56# @ECLASS-VARIABLE: DOCS
31SCROLLKEEPER_DIR=${SCROLLKEEPER_DIR:="${ROOT}var/lib/scrollkeeper"} 57# @DEFAULT-UNSET
58# @DESCRIPTION:
59# String containing documents passed to dodoc command.
32 60
33# Path to scrollkeeper-update 61# @ECLASS-VARIABLE: GCONF_DEBUG
34SCROLLKEEPER_UPDATE_BIN=${SCROLLKEEPER_UPDATE_BIN:="${ROOT}usr/bin/scrollkeeper-update"} 62# @DEFAULT_UNSET
63# @DESCRIPTION:
64# Whether to handle debug or not.
65# Some gnome applications support various levels of debugging (yes, no, minimum,
66# etc), but using --disable-debug also removes g_assert which makes debugging
67# harder. This variable should be set to yes for such packages for the eclass
68# to handle it properly. It will enable minimal debug with USE=-debug.
69# Note that this is most commonly found in configure.ac as GNOME_DEBUG_CHECK.
35 70
36# Path to gconftool-2
37GCONFTOOL_BIN=${GCONFTOOL_BIN:="${ROOT}usr/bin/gconftool-2"}
38 71
39if [[ ${GCONF_DEBUG} != "no" ]]; then 72if [[ ${GCONF_DEBUG} != "no" ]]; then
40 IUSE="debug" 73 IUSE="debug"
41fi 74fi
42 75
43DEPEND=">=sys-apps/sed-4"
44 76
77# @FUNCTION: gnome2_src_unpack
78# @DESCRIPTION:
79# Stub function for old EAPI.
45gnome2_src_unpack() { 80gnome2_src_unpack() {
46 unpack ${A} 81 unpack ${A}
47 cd ${S} 82 cd "${S}"
83 has ${EAPI:-0} 0 1 && gnome2_src_prepare
84}
48 85
86# @FUNCTION: gnome2_src_prepare
87# @DESCRIPTION:
88# Fix build of scrollkeeper documentation and run elibtoolize.
89gnome2_src_prepare() {
49 # Prevent scrollkeeper access violations 90 # Prevent scrollkeeper access violations
50 gnome2_omf_fix 91 gnome2_omf_fix
51}
52 92
93 # Run libtoolize
94 if has ${EAPI:-0} 0 1 2 3; then
95 elibtoolize ${ELTCONF}
96 else
97 # Everything is fatal EAPI 4 onwards
98 nonfatal elibtoolize ${ELTCONF}
99 fi
100
101}
102
103# @FUNCTION: gnome2_src_configure
104# @DESCRIPTION:
105# Gnome specific configure handling
53gnome2_src_configure() { 106gnome2_src_configure() {
54 # Update the GNOME configuration options 107 # Update the GNOME configuration options
55 if [[ ${GCONF_DEBUG} != 'no' ]] ; then 108 if [[ ${GCONF_DEBUG} != 'no' ]] ; then
56 if use debug ; then 109 if use debug ; then
57 G2CONF="${G2CONF} --enable-debug=yes" 110 G2CONF="${G2CONF} --enable-debug=yes"
58 fi 111 fi
59 fi 112 fi
60 113
61 # Prevent a QA warning 114 # Prevent a QA warning
62 if hasq doc ${IUSE} ; then 115 if has doc ${IUSE} ; then
63 G2CONF="${G2CONF} $(use_enable doc gtk-doc)" 116 G2CONF="${G2CONF} $(use_enable doc gtk-doc)"
64 fi 117 fi
65 118
66 # Run libtoolize
67 elibtoolize ${ELTCONF}
68
69 # Avoid sandbox violations caused by misbehaving packages (bug #128289) 119 # Avoid sandbox violations caused by misbehaving packages (bug #128289)
70 addwrite "${ROOT}root/.gnome2" 120 addwrite "/root/.gnome2"
71 121
72 # GST_REGISTRY is to work around gst-inspect trying to read/write /root 122 # GST_REGISTRY is to work around gst-inspect trying to read/write /root
73 GST_REGISTRY="${S}/registry.xml" econf "$@" ${G2CONF} || die "configure failed" 123 GST_REGISTRY="${S}/registry.xml" econf "$@" ${G2CONF}
74} 124}
75 125
126# @FUNCTION: gnome2_src_compile
127# @DESCRIPTION:
128# Stub function for old EAPI.
76gnome2_src_compile() { 129gnome2_src_compile() {
77 gnome2_src_configure "$@" 130 has ${EAPI:-0} 0 1 && gnome2_src_configure "$@"
78 emake || die "compile failure" 131 emake || die "compile failure"
79} 132}
80 133
134# @FUNCTION: gnome2_src_install
135# @DESCRIPTION:
136# Gnome specific install. Handles typical GConf and scrollkeeper setup
137# in packages and removal of .la files if requested
81gnome2_src_install() { 138gnome2_src_install() {
139 has ${EAPI:-0} 0 1 2 && ! use prefix && ED="${D}"
82 # if this is not present, scrollkeeper-update may segfault and 140 # if this is not present, scrollkeeper-update may segfault and
83 # create bogus directories in /var/lib/ 141 # create bogus directories in /var/lib/
84 local sk_tmp_dir="/var/lib/scrollkeeper" 142 local sk_tmp_dir="/var/lib/scrollkeeper"
85 dodir "${sk_tmp_dir}" 143 dodir "${sk_tmp_dir}" || die "dodir failed"
86 144
87 # we must delay gconf schema installation due to sandbox 145 # we must delay gconf schema installation due to sandbox
88 export GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL="1" 146 export GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL="1"
89 147
90 if [[ -z "${USE_EINSTALL}" || "${USE_EINSTALL}" = "0" ]]; then 148 if [[ -z "${USE_EINSTALL}" || "${USE_EINSTALL}" = "0" ]]; then
91 debug-print "Installing with 'make install'" 149 debug-print "Installing with 'make install'"
92 make DESTDIR=${D} "scrollkeeper_localstate_dir=${D}${sk_tmp_dir} " "$@" install || die "install failed" 150 emake DESTDIR="${D}" "scrollkeeper_localstate_dir=${ED}${sk_tmp_dir} " "$@" install || die "install failed"
93 else 151 else
94 debug-print "Installing with 'einstall'" 152 debug-print "Installing with 'einstall'"
95 einstall "scrollkeeper_localstate_dir=${D}${sk_tmp_dir} " "$@" || die "einstall failed" 153 einstall "scrollkeeper_localstate_dir=${ED}${sk_tmp_dir} " "$@" || die "einstall failed"
96 fi 154 fi
97 155
98 unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL 156 unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL
99 157
100 # Manual document installation 158 # Manual document installation
101 [[ -n "${DOCS}" ]] && dodoc ${DOCS} 159 if [[ -n "${DOCS}" ]]; then
160 dodoc ${DOCS} || die "dodoc failed"
161 fi
102 162
103 # Do not keep /var/lib/scrollkeeper because: 163 # Do not keep /var/lib/scrollkeeper because:
104 # 1. The scrollkeeper database is regenerated at pkg_postinst() 164 # 1. The scrollkeeper database is regenerated at pkg_postinst()
105 # 2. ${D}/var/lib/scrollkeeper contains only indexes for the current pkg 165 # 2. ${ED}/var/lib/scrollkeeper contains only indexes for the current pkg
106 # thus it makes no sense if pkg_postinst ISN'T run for some reason. 166 # thus it makes no sense if pkg_postinst ISN'T run for some reason.
107 if [[ -z "$(find ${D} -name '*.omf')" ]]; then 167 if [[ -z "$(find "${D}" -name '*.omf')" ]]; then
108 export SCROLLKEEPER_UPDATE="0" 168 export SCROLLKEEPER_UPDATE="0"
109 fi 169 fi
110 rm -rf "${D}${sk_tmp_dir}" 170 rm -rf "${ED}${sk_tmp_dir}"
111 171
112 # Make sure this one doesn't get in the portage db 172 # Make sure this one doesn't get in the portage db
113 rm -fr "${D}/usr/share/applications/mimeinfo.cache" 173 rm -fr "${ED}/usr/share/applications/mimeinfo.cache"
114}
115 174
116 175 # Delete all .la files
117 176 if [[ "${GNOME2_LA_PUNT}" != "no" ]]; then
118# Applies any schema files installed by the current ebuild to Gconf's database 177 ebegin "Removing .la files"
119# using gconftool-2 178 find "${D}" -name '*.la' -exec rm -f {} + || die "la file removal failed"
120gnome2_gconf_install() { 179 eend
121 if [[ ! -x ${GCONFTOOL_BIN} ]]; then
122 return
123 fi
124
125 # We are ready to install the GCONF Scheme now
126 unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL
127 export GCONF_CONFIG_SOURCE=$(${GCONFTOOL_BIN} --get-default-source)
128
129 einfo "Installing GNOME 2 GConf schemas"
130
131 local contents="${ROOT}/var/db/pkg/*/${PN}-${PVR}/CONTENTS"
132 local F
133
134 for F in $(grep "^obj /etc/gconf/schemas/.\+\.schemas\b" ${contents} | gawk '{print $2}' ); do
135 if [[ -e "${F}" ]]; then
136 # echo "DEBUG::gconf install ${F}"
137 ${GCONFTOOL_BIN} --makefile-install-rule ${F} 1>/dev/null
138 fi 180 fi
139 done
140
141 # have gconf reload the new schemas
142 ebegin "Reloading GConf schemas"
143 killall -HUP gconfd-2
144 eend $?
145} 181}
146 182
147# Removes schema files previously installed by the current ebuild from Gconf's 183# @FUNCTION: gnome2_pkg_preinst
148# database. 184# @DESCRIPTION:
149gnome2_gconf_uninstall() { 185# Finds Icons, GConf and GSettings schemas for later handling in pkg_postinst
150 if [[ ! -x ${GCONFTOOL_BIN} ]]; then 186gnome2_pkg_preinst() {
151 return 187 gnome2_gconf_savelist
152 fi 188 gnome2_icon_savelist
153 189 gnome2_schemas_savelist
154 unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL
155 export GCONF_CONFIG_SOURCE=$(${GCONFTOOL_BIN} --get-default-source)
156
157 einfo "Uninstalling GNOME 2 GConf schemas"
158
159 local contents="${ROOT}/var/db/pkg/*/${PN}-${PVR}/CONTENTS"
160 local F
161
162 for F in $(grep "obj /etc/gconf/schemas" ${contents} | sed 's:obj \([^ ]*\) .*:\1:' ); do
163 # echo "DEBUG::gconf install ${F}"
164 ${GCONFTOOL_BIN} --makefile-uninstall-rule ${F} 1>/dev/null
165 done
166} 190}
167 191
168# Updates Gtk+ icon cache files under /usr/share/icons if the current ebuild 192# @FUNCTION: gnome2_pkg_postinst
169# have installed anything under that location. 193# @DESCRIPTION:
170gnome2_icon_cache_update() { 194# Handle scrollkeeper, GConf, GSettings, Icons, desktop and mime
171 local updater=$(type -p gtk-update-icon-cache 2> /dev/null) 195# database updates.
172
173 if [[ ! -x ${updater} ]] ; then
174 debug-print "${updater} is not executable"
175
176 return
177 fi
178
179 if ! grep -q "obj /usr/share/icons" ${ROOT}/var/db/pkg/*/${PF}/CONTENTS
180 then
181 debug-print "No items to update"
182
183 return
184 fi
185
186 ebegin "Updating icons cache"
187
188 local retval=0
189 local fails=( )
190
191 for dir in $(find ${ROOT}/usr/share/icons -maxdepth 1 -mindepth 1 -type d)
192 do
193 if [[ -f "${dir}/index.theme" ]] ; then
194 local rv=0
195
196 ${updater} -qf ${dir}
197 rv=$?
198
199 if [[ ! $rv -eq 0 ]] ; then
200 debug-print "Updating cache failed on ${dir}"
201
202 # Add to the list of failures
203 fails[$(( ${#fails[@]} + 1 ))]=$dir
204
205 retval=2
206 fi
207 fi
208 done
209
210 eend ${retval}
211
212 for (( i = 0 ; i < ${#fails[@]} ; i++ )) ; do
213 ### HACK!! This is needed until bash 3.1 is unmasked.
214 ## The current stable version of bash lists the sizeof fails to be 1
215 ## when there are no elements in the list because it is declared local.
216 ## In order to prevent the declaration from being in global scope, we
217 ## this hack to prevent an empty error message being printed for stable
218 ## users. -- compnerd && allanonjl
219 if [[ "${fails[i]}" != "" && "${fails[i]}" != "()" ]] ; then
220 eerror "Failed to update cache with icon ${fails[i]}"
221 fi
222 done
223}
224
225# Workaround applied to Makefile rules in order to remove redundant
226# calls to scrollkeeper-update and sandbox violations.
227gnome2_omf_fix() {
228 local omf_makefiles filename
229
230 omf_makefiles="$@"
231
232 if [[ -f ${S}/omf.make ]] ; then
233 omf_makefiles="${omf_makefiles} ${S}/omf.make"
234 fi
235
236 # testing fixing of all makefiles found
237 for filename in $(find ./ -name "Makefile.in" -o -name "Makefile.am") ; do
238 omf_makefiles="${omf_makefiles} ${filename}"
239 done
240
241 ebegin "Fixing OMF Makefiles"
242
243 local retval=0
244 local fails=( )
245
246 for omf in ${omf_makefiles} ; do
247 local rv=0
248
249 sed -i -e 's:scrollkeeper-update:true:' ${omf}
250 retval=$?
251
252 if [[ ! $rv -eq 0 ]] ; then
253 debug-print "updating of ${omf} failed"
254
255 # Add to the list of failures
256 fails[$(( ${#fails[@]} + 1 ))]=$omf
257
258 retval=2
259 fi
260 done
261
262 eend $retval
263
264 for (( i = 0 ; i < ${#fails[@]} ; i++ )) ; do
265 ### HACK!! This is needed until bash 3.1 is unmasked.
266 ## The current stable version of bash lists the sizeof fails to be 1
267 ## when there are no elements in the list because it is declared local.
268 ## In order to prevent the declaration from being in global scope, we
269 ## this hack to prevent an empty error message being printed for stable
270 ## users. -- compnerd && allanonjl
271 if [[ "${fails[i]}" != "" && "${fails[i]}" != "()" ]] ; then
272 eerror "Failed to update OMF Makefile ${fails[i]}"
273 fi
274 done
275}
276
277# Updates the scrollkeeper database if necessary. To force this action, make
278# sure to set SCROLLKEPER_UPDATE to 1.
279gnome2_scrollkeeper_update() {
280 if [[ -x ${SCROLLKEEPER_UPDATE_BIN} && "${SCROLLKEEPER_UPDATE}" = "1" ]]
281 then
282 einfo "Updating scrollkeeper database ..."
283 ${SCROLLKEEPER_UPDATE_BIN} -q -p ${SCROLLKEEPER_DIR}
284 fi
285}
286
287gnome2_pkg_postinst() { 196gnome2_pkg_postinst() {
288 gnome2_gconf_install 197 gnome2_gconf_install
289 gnome2_scrollkeeper_update
290 fdo-mime_desktop_database_update 198 fdo-mime_desktop_database_update
291 fdo-mime_mime_database_update 199 fdo-mime_mime_database_update
292 gnome2_icon_cache_update 200 gnome2_icon_cache_update
293} 201 gnome2_schemas_update
294 202
203 if [[ "${SCROLLKEEPER_UPDATE}" = "1" ]]; then
204 gnome2_scrollkeeper_update
205 fi
206}
207
208# @#FUNCTION: gnome2_pkg_prerm
209# @#DESCRIPTION:
210# # FIXME Handle GConf schemas removal
295#gnome2_pkg_prerm() { 211#gnome2_pkg_prerm() {
296# gnome2_gconf_uninstall 212# gnome2_gconf_uninstall
297#} 213#}
298 214
215# @FUNCTION: gnome2_pkg_postrm
216# @DESCRIPTION:
217# Handle scrollkeeper, GSettings, Icons, desktop and mime database updates.
299gnome2_pkg_postrm() { 218gnome2_pkg_postrm() {
300 gnome2_scrollkeeper_update
301 fdo-mime_desktop_database_update 219 fdo-mime_desktop_database_update
302 fdo-mime_mime_database_update 220 fdo-mime_mime_database_update
303 gnome2_icon_cache_update 221 gnome2_icon_cache_update
304} 222 gnome2_schemas_update --uninstall
305 223
306EXPORT_FUNCTIONS src_unpack src_compile src_install pkg_postinst pkg_postrm 224 if [[ "${SCROLLKEEPER_UPDATE}" = "1" ]]; then
225 gnome2_scrollkeeper_update
226 fi
227}

Legend:
Removed from v.1.77  
changed lines
  Added in v.1.97

  ViewVC Help
Powered by ViewVC 1.1.20